
class ErrorHandler
{
    constructor(options) {
        if ( options ) {
            if ( "url" in options ) {
                this.url = options['url'];
            }
            else {
                // throw une erreur ici
            }

            if ( "apikey" in options ) {
                this.apikey = options['apikey'];
            }
            else {
                // throw une erreur ici
            }
        }

        this.catchError();
    }

    catchError() {
        window.onerror = function(message, url, line, column, error) {
            // build l'url ET l'api key ensemble pour créer l'URL de réception de bug

            fetch(this.url ? this.url : window.location.href, {
                method: "post",
                headers: {
                    'Accept': "application/json",
                    'Content-Type': "application/json",
                    'User-Agent': "NegundoClient/1.0"
                },
                body: JSON.stringify({
                    message: message,
                    url: url,
                    line: line,
                    column: column,
                    stack: error.stack,
                    location: window.location.toString()
                })
            }).then( response => response ).then(data => {
                console.info("Error reported", data);
            });

            return false;
        }.bind(this);
    }

    get url() {
        return this._url;
    }

    set url(set) {
        return this._url = set;
    }

    get apikey() {
        return this._url;
    }

    set apikey(set) {
        return this._url = set;
    }
}
