<?php

namespace Negundo\Client\Util;

class SourceCodeFormatter {
    
    public function generateFromException(\Throwable $ex, int $lineCount = 12) : string 
    {
        return $this->generateFromFile($ex->getFile(), $ex->getLine(), $lineCount);
    }
    
    public function generateFromFile(string $filePath, int $sourceLine, int $lineCount = 12) : string
    {
        if ( empty( $filePath ) ){
            return "";
        }

        ini_set('highlight.default', "#0072bc");
        ini_set('highlight.string' , "#bc0000");
        ini_set('highlight.comment', "#b69832");

        $lc2 = $lineCount / 2;
        
        $seek = $sourceLine - (int) floor($sourceLine >= $lc2 ? $lc2 : $sourceLine);
        
        $fileSpl = new \SplFileObject($filePath);
        
        $fileSpl->seek($seek);
        
        $html = "";

        $err = error_reporting();

        error_reporting(0);

        for($line = $seek; $line < $seek + $lineCount; $line++) {
            try {
                # Highlighting code
                $content = highlight_string("<?php ".$fileSpl->current(), true);
            }
            catch(\Throwable $e) {
                $content = $fileSpl->current();
            }
            
            # Get code between <code></code> tags
            $content = substr($content, strpos($content, "<code>") + 6, strrpos($content, "</code>") - 6);
            
            # Removing the added <?php tag
            $content = str_replace("&lt;?php", "", $content);
            
            $html .= "<div data-line='" . ($line + 1) . "' class='source-line'>" . $content . "</div>";
            
            $fileSpl->next();
            
            if ( $fileSpl->eof() ) {
                $html .= "<div class='source-line eof'></div>";
                break;
            }
        }

        error_reporting($err);

        return $html;
    }
}
